<?
	
class App {
	
	function App() {

	}
	
	function setID($id) {
		$this->id = $id;
	}
	
	function getID() {
		return $this->id;
	}
	
	function setName($name) {
		$this->name = $name;
	}
	
	function getName() {
		return $this->name;
	}
	
	function setAlias($alias) {
		$this->alias = $alias;
	}
	
	function getAlias() {
		return $this->alias;
	}
	
	function setAuth($auth) {
		$this->auth = $auth;
	}
	
	function getAuth() {
		return $this->auth;
	}
	
	function setIface($iface) {
		$this->iface = $iface;
	}
	
	function getIface() {
		return $this->iface;
	}
	
	function setLog($log) {
		$this->log = $log;
	}
	
	function getLog() {
		return $this->log;
	}

	function setFilter($filter) {
		$this->filter = $filter;
	}
	
	function getFilter() {
		return $this->filter;
	}
	
	function setAccess($access) {
		$this->access = $access;
	}
	
	function getAccess() {
		return $this->access;
	}
	
	function setAccessConfig($access_config) {
		$this->access_config = $access_config;
	}
	
	function getAccessConfig() {
		return $this->access_config;
	}

	function setRewrite($rewrite_rules) {
		$this->rewrite = $rewrite_rules;
	}
	
	function getRewrite() {
		return $this->rewrite;
	}
	
	function setHeaders($headers) {
		$this->headers = $headers;
	}
	
	function getHeaders() {
		return $this->headers;
	}

	function setHasHeaders($has_headers) {
		$this->has_headers = $has_headers;
	}
	
	function getHasHeaders() {
		return $this->has_headers;
	}

	function setFilterConfig($filter_config) {
		$this->filter_config = $filter_config;
	}
	
	function getFilterConfig() {
		return $this->filter_config;
	}
	
	function setUrl($url) {
		$this->url = $url;
	}
	
	function getUrl() {
		return $this->url;
	}
	  
	function getCA() {
		return $this->ca;
	}
	
	function setCA($ca) {
		$this->ca = $ca;
	}

	function getCAID() {
		return $this->ca;
	}
	
	function setCAID($ca_id) {
		$this->ca_id = $ca_id;
	}

	function getIsPost() {
		return $this->is_post;
	}
	
	function setIsPost($id) {
		$this->is_post = $id;
	}

	function getPostUrl() {
		return $this->post_url;
	}
	
	function setPostUrl($url) {
		$this->post_url = $url;
	}

	function setSSOForwardType($type) {
		$this->sso_forward_type = $type;
	}

	function getSSOForwardType() {
		return $this->sso_forward_type;
	}
	
	function setAutoLogon($autologon) {
		$this->autologon = $autologon;
	}

	function getAutoLogon() {
		return $this->autologon;
	}

	function update($db) {
		global $i18n;		
	
		$query = "
			SELECT * FROM app 
			WHERE name='". sqlite_escape_string($this->getName()) ."' 
			AND if='". sqlite_escape_string($this->getIface()) ."' 
			AND id!='".sqlite_escape_string($this->getID())."'
		";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " " . $i18n["already_exists"];
	
		if ($this->getAutoLogon()=="t" && $this->getSSOForwardType()=="post") {
			$query = "
				SELECT * FROM post 
				WHERE id_app = '". sqlite_escape_string($this->getID())."'
				AND field_type='autologon_user'
			";
			$result = $db->query($query);
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				print_r($result);
				return TRUE;
			}
			if ($result->numrows()!=1) {
				return $i18n["autologon_missing"];
			}
			$query = "
				SELECT * FROM post 
				WHERE id_app = '". sqlite_escape_string($this->getID())."'
				AND field_type='autologon_password'
			";
			$result = $db->query($query);
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				print_r($result);
				return TRUE;
			}
			if ($result->numrows() != 1) {
				return $i18n["autologon_missing"];
			}
		}

		$query = "
			UPDATE app SET name 		= '".sqlite_escape_string ($this->getName())."',
				       alias 		= '".sqlite_escape_string ($this->getAlias())."',
				       auth 		= '".sqlite_escape_string ($this->getAuth())."',
				       if 		= '".sqlite_escape_string ($this->getIface())."',
				       log 		= '".sqlite_escape_string ($this->getLog())."',
				       url 		= '".sqlite_escape_string ($this->getUrl())."',
				       sso_forward_type = '".sqlite_escape_string ($this->getSSOForwardType())."',
				       autologon 	= '".sqlite_escape_string ($this->getAutoLogon())."',
				       is_post		= '".sqlite_escape_string ($this->getIsPost())."',
				       post_url		= '".sqlite_escape_string ($this->getPostUrl())."',
				       rewrite		= '".sqlite_escape_string ($this->getRewrite())."',
				       filter_config 	= '".sqlite_escape_string ($this->getFilterConfig())."', 
				       access_config 	= '".sqlite_escape_string ($this->getAccessConfig())."',
				       has_headers 	= '".($this->getHasHeaders() ? "t" : "f")."'
			WHERE id='".sqlite_escape_string($this->getID())."'";

		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$query = "DELETE FROM app_filter WHERE id_app='".sqlite_escape_string($this->getID())."'";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($this->getFilter()) {	
			foreach ($this->getFilter() as $id_filter) {
				if ($id_filter=="") continue;
				$query = "INSERT INTO app_filter (id_app, id_filter) values ('".sqlite_escape_string($this->getID())."', '".sqlite_escape_string($id_filter). "')";
				$result = $db->query($query);
				if (DB::isError($result)) {
					print "Error: " . __FUNCTION__ . "() in " . __FILE__;
					print_r($result);
					return TRUE;
				}
			}
		}
		return FALSE;
	}
	
	function select($db, $id) {

		$query = "SELECT * FROM app WHERE id='".sqlite_escape_string($id)."'";

		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$this->setName		(stripslashes ($row['name']));
		$this->setAlias		(stripslashes ($row['alias']));
		$this->setUrl		(stripslashes ($row['url']));
		$this->setAuth		(stripslashes ($row['auth']));
		$this->setIface		(stripslashes ($row['if']));
		$this->setLog		(stripslashes ($row['log']));
		$this->setRewrite	(stripslashes ($row['rewrite']));
		$this->setFilterConfig	(stripslashes ($row['filter_config']));
		$this->setAccessConfig	(stripslashes ($row['access_config']));
		$this->setIsPost	(stripslashes ($row['is_post']));
		$this->setSSOForwardType(stripslashes ($row['sso_forward_type']));
		$this->setAutoLogon	(stripslashes ($row['autologon']));
		$this->setPostUrl	(stripslashes ($row['post_url']));
		$this->setHasHeaders	($row['has_headers'] == "t");
		$this->setID		($id);

		$query = "SELECT * FROM app_filter WHERE id_app='".sqlite_escape_string($id)."'";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$filter=array();
		while ($row=$result->fetchrow (DB_FETCHMODE_ASSOC)) {
			$filter[] = $row['id_filter'];
		}
		$this->setFilter ($filter);
		
		$query = "SELECT * FROM headers WHERE id_app='".sqlite_escape_string($id)."'";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$headers = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$headers[] = array('id' => sqlite_escape_string($row['id']),
					   'var' => sqlite_escape_string($row['var']),
					   'value' => sqlite_escape_string($row['value'])
					   );
		}
		$this->setHeaders($headers);
		return FALSE;
	}
	
	function insert($db) {
		global $i18n;

		$query = "
			SELECT * FROM app
			WHERE name='".sqlite_escape_string($this->getName())."'
			AND if='". sqlite_escape_string($this->getIface()) ."' ";

		$result = $db->query($query); 
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($result->fetchRow(DB_FETCHMODE_ASSOC))
			return $this->getName() . " " . $i18n["already_exists"];
		
		$query = "
			INSERT INTO app (name, alias, auth, if, log, url, rewrite,
					sso_forward_type, autologon, is_post,
					post_url, filter_config, access_config, up)
			VALUES(".
			"'" . sqlite_escape_string($this->getName()). "', ".
			"'" . sqlite_escape_string($this->getAlias()). "', ".
			"'" . sqlite_escape_string($this->getAuth()). "', ".
			"'" . sqlite_escape_string($this->getIface()). "', ".
			"'" . sqlite_escape_string($this->getLog()). "', ".
			"'" . sqlite_escape_string($this->getUrl()). "', ".
			"'" . sqlite_escape_string($this->getRewrite()). "', ".
			"'" . sqlite_escape_string($this->getSSOForwardType()). "', ".
			"'" . sqlite_escape_string($this->getAutoLogon()). "', ".
			"'" . sqlite_escape_string($this->getIsPost()). "', ".
			"'" . sqlite_escape_string($this->getPostUrl()). "', ".
			"'" . sqlite_escape_string($this->getFilterConfig()). "', ".
			"'" . sqlite_escape_string($this->getAccessConfig()). "', ".
			"'" . 1 . "'".
			")";
		$result = $db->query($query); 
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$query = "
				SELECT id 
				FROM app 
				WHERE 	name		= '" . sqlite_escape_string($this->getName()). "'
				AND 	alias		= '" . sqlite_escape_string($this->getAlias()). "'
				AND 	auth		= '" . sqlite_escape_string($this->getAuth()). "'
				AND 	if		= '" . sqlite_escape_string($this->getIface()). "'
				AND 	log		= '" . sqlite_escape_string($this->getLog()). "'
				AND 	url		= '" . sqlite_escape_string($this->getUrl()). "'
				AND 	rewrite		= '" . sqlite_escape_string($this->getRewrite()). "'
				AND 	filter_config	= '" . sqlite_escape_string($this->getFilterConfig()). "'
				AND 	access_config	= '" . sqlite_escape_string($this->getAccessConfig()). "'
				ORDER BY id DESC
				LIMIT 1
			";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}	
		$row 	= $result->fetchRow(DB_FETCHMODE_ASSOC);
		$id_app = $row ['id'];
		foreach ($this->getFilter() as $id_filter) {
			$query = "INSERT INTO app_filter (id_app, id_filter) values ('$id_app', '".sqlite_escape_string($id_filter). "')";
			$result = $db->query($query);
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				print_r($result);
				return TRUE;
			}
		}
		return FALSE;
	}

}	
?>
