<?
	
class CA {
	
	function CA() {
	
	}
	
	function setID($id) {
		$this->id = $id;
	}
	
	function getID() {
		return $this->id;
	}
	
	function getName() {
		return $this->name;
	}
	
	function setName($name) {
		$this->name = $name;
	}
	
	function getConstraint() {
		return $this->ssl_constraint;
	}
	
	function setConstraint($ssl_constraint) {
		$this->ssl_constraint = $ssl_constraint;
	}
	
	function getRequire() {
		return $this->ca_require;
	}
	
	function setRequire($flag) {
		$this->ca_require = $flag;
	}
	
	function setCrt($crt) {
		$this->crt = $crt;
	}
	
	function getCrt() {
		return $this->crt;
	}
	
	function getRootDir() {
		global $IntfRootDir;
		return $IntfRootDir;
	}
	
	function delete($db) {

		global $i18n;
		$id = $this->getID();
		$query = "SELECT id FROM auth WHERE id_auth='".sqlite_escape_string($id)."' AND type='2'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}

		if ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$query = "SELECT id FROM app WHERE auth='".$row['id']."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				print_r($result);
				return TRUE;
			}
			if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $i18n["auth_used"];
		}

		$query = "DELETE FROM ca WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$query = "DELETE FROM auth WHERE id_auth='".sqlite_escape_string($id)."' AND type='2'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function update($db) {
	
		global $i18n;
	
		$query = "SELECT * FROM ca WHERE name='". sqlite_escape_string($this->getName()) ."' AND id !='".sqlite_escape_string($this->getID())."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		} 
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " ". $i18n["already_exists"];
	
		$query = "UPDATE ca SET ".
			"name='". 	sqlite_escape_string($this->getName()) . "', ".
			"ssl_constraint='".sqlite_escape_string($this->getConstraint()) . "', ".
			"require='". 	sqlite_escape_string($this->getRequire()) . "', ".
			"crt='". 	sqlite_escape_string($this->getCrt()) . "' ".
			"WHERE id='".	sqlite_escape_string($this->getID())."'";

		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function select($db, $id) {
		$query = "SELECT * FROM ca WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$this->setName		(stripslashes ($row['name']));
		$this->setConstraint	(stripslashes ($row['ssl_constraint']));
		$this->setRequire	(stripslashes ($row['require']));
		$this->setCrt		(stripslashes ($row['crt']));
		$this->setID($id);
		return FALSE;
	}
	
	function insert($db) {

		global $i18n;

		$query = "SELECT * FROM filter WHERE name='".sqlite_escape_string($this->getName())."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " ". $i18n["already_exists"];

		$query = "INSERT INTO ca (crt, require, ssl_constraint, name) 
			VALUES('" . 	sqlite_escape_string($this->getCrt()). 
				"', '".	sqlite_escape_string($this->getRequire()). 
				"', '".	sqlite_escape_string($this->getConstraint()). 
				"', '".	sqlite_escape_string($this->getName()). "')
		";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$query = "SELECT * FROM ca WHERE name='". sqlite_escape_string($this->getName()) ."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$row['id'];
		$query = "INSERT INTO auth (type, id_auth) VALUES('2','".$row['id']."')";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}

}
	
?>
