<?php

include_once "AbstractAction.php";
include_once "Filter.php";

class FilterAction extends AbstractAction {

	function FilterAction() {
	}

	function execute($mapping, $form, &$request, &$response) {

		parent::execute();

		$this->setForward('ko');
		$db = $this->getDS('MyDS');

		if (($del = $request->getParameter('del'))) {
			$filter = new Filter();
			$filter->select($db, $del);
			if ($err = $filter->delete($db)) {
				$request->setAttribute('errors', $err);
			}
		}

		$query = "SELECT id FROM filter ORDER BY name";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);
		}
		$filters = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$filter = new Filter();
			$filter->select($db, $row['id']);
			$filters[] = $filter;
		}

		$request->setAttribute('filters', $filters);
		$this->setForward('ok');

		return $this->getForward($mapping);
	}
}

?>
