<?php
	
include_once "AbstractAction.php";
include_once "If.php";
	
class IfAction extends AbstractAction {
	
	function IfAction() {
	}
	
	function execute($mapping, $form, &$request, &$response) {

		parent::execute();

		$this->setForward('ko');
	
		$db = $this->getDS('MyDS');
		$db->setFetchMode(DB_FETCHMODE_ASSOC);
	
		if ($del = $request->getParameter('del')) {
			$if = new Intf();
			$if->select($db, $del);
			if($err = $if->delete($db)) $request->setAttribute('errors', $err);
		}
		elseif ($restart = $request->getParameter('restart')) {
			$if = new Intf();
			$if->select($db, $restart);
			if ($err = $if->restart($db)) $request->setAttribute('errors', $err);
		}
		elseif ($stop = $request->getParameter('stop')) {
			$if = new Intf();
			$if->select($db, $stop);
			$if->stop();
		}
	
		$query = "SELECT id FROM if ORDER BY name";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);
		}
		$ifs = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$if = new Intf();
			$if->select($db, $row['id']);

			if (	$if->getConfFile() != $if->buildConf($db) ||
			    	$if->getCrtFile() != $if->getCrt($db) ||
			    	$if->getKeyFile() != $if->getKey($db) ||
			    	!$if->status()
			) $if->setNeedRestart(1);
			
			$ifs[] = $if;
		}

		$query = "SELECT id, name FROM log ORDER BY name";
                $result = $db->query("$query");
                if (DB::isError($result)) {
                        print "Error: " . __FUNCTION__ . "() in " . __FILE__;
                        $request->setAttribute('errors', $result);
                        return $this->getForward($mapping);
                }               
                $log=array();
                while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
                        $log[$row['id']] = $row['name'];
                }

		$request->setAttribute('log', $log);
		$request->setAttribute('ifs', $ifs);
		$this->setForward('ok');
		
		return $this->getForward($mapping);
	}
}
	
?>
