<?
	
class Logs {
	
	function Logs() {
	
	}
	
	function setID($id) {
		$this->id = $id;
	}
	
	function getID() {
		return $this->id;
	}
	
	function getName() {
		return $this->name;
	}
	
	function setName($name) {
		$this->name = $name;
	}
	
	function getRules() {
		return $this->rules;
	}
	
	function setRules($rules) {
		$this->rules = $rules;
	}
	
	function delete($db) {

		global $i18n;
		$id = $this->getID();

		$query = "SELECT log FROM app WHERE log='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $i18n["log_used"];
			
		$query = "DELETE FROM log WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function update($db) {
		global $i18n;
	
		$query = "SELECT * FROM log WHERE name='".sqlite_escape_string($this->getName())."' AND id !='".sqlite_escape_string($this->getID())."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
    		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " ". $i18n["already_exists"];

		$query = "UPDATE log 
			SET name='".	sqlite_escape_string($this->getName()). 
			"', rules='". 	sqlite_escape_string($this->getRules()) . 
			"' WHERE id='".	sqlite_escape_string($this->getID())."'
		";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function select($db, $id) {
		$query = "SELECT * FROM log WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$this->setName	(stripslashes ($row['name']));
		$this->setRules	(stripslashes ($row['rules']));
		$this->setID	($id);
		return FALSE;
	}
	
	function insert($db) {
		global $i18n;
	
		$query = "SELECT * FROM log WHERE name='".sqlite_escape_string($this->getName())."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
    		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " ". $i18n["already_exists"];

		$query = "INSERT INTO log (name, rules) VALUES ('".sqlite_escape_string($this->getName())."','".sqlite_escape_string ($this->getRules())."')";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
}
	
?>
