<?php

include_once "AbstractAction.php";
include_once "Profile.php";

class ProfilesAction extends AbstractAction {

	function execute($mapping, $form, &$request, &$response) {

		parent::execute();

		$this->setForward('ko');
		$db = $this->getDS('MyDS');

		if (($del = $request->getParameter('del'))) {
			$profile = new Profile();
			$profile->select($db, $del);
			if ($err = $profile->delete($db)) {
				$request->setAttribute('errors', $err);
			}
		}

		$query = "SELECT id FROM profile GROUP BY id_app, user ORDER BY user";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);
		}
		$profiles = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$profile = new Profile();
			$profile->select($db, $row['id']);
			$profiles[] = $profile;
		}

		$request->setAttribute('profiles', $profiles);
		$this->setForward('ok');

		return $this->getForward($mapping);
	}
}

?>