<?

class User {

	function User() {
	}

	function setID($id) {
		$this->id = $id;
	}

	function getID() {
		return $this->id;
	}

	function getLogin() {
		return $this->login;
	}

	function setLogin($login) {
		$this->login = $login;
	}

	function getFirstName() {
		return $this->firstname;
	}

	function setFirstName($firstname) {
		$this->firstname = stripslashes ($firstname);
	}
	
	function getLastName() {
		return $this->lastname;
	}

	function setLastName($lastname) {
		$this->lastname = stripslashes ($lastname);
	}

	function getPassword() {
		return $this->pass;
	}

	function setPassword($pass) {
		$this->pass = $pass;
	}

	function getAdmin() {
		return $this->is_admin;
	}

	function setAdmin($is_admin) {
		if ($is_admin=="on") $is_admin="t";
		$this->is_admin = $is_admin;
	}

	function update($db) {
		global $i18n;

		$query = "SELECT * FROM user WHERE login='".sqlite_escape_string($this->getLogin())."' AND id !='".sqlite_escape_string($this->getID())."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getLogin() . " ". $i18n["already_exists"];

		$query = "
			UPDATE user SET login 		='".sqlite_escape_string($this->getLogin())."',
					firstname	='".sqlite_escape_string($this->getFirstName())."',
					lastname	='".sqlite_escape_string($this->getLastName())."',
					password	='".sqlite_escape_string($this->getPassword())."',
					is_admin	='".sqlite_escape_string($this->getAdmin())."'
					WHERE id	='".sqlite_escape_string($this->getID())."'
		";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		} 
		return FALSE;
	}
	
	function select($db, $id, $type = 0) {
		$query = "SELECT * FROM user WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$this->setLogin($row['login']);
		$this->setFirstName($row['firstname']);
		$this->setLastName($row['lastname']);
		$this->setPassword($row['password']);
		$this->setAdmin($row['is_admin']);
		$this->setID($id);
		return FALSE;
	}

	function delete($db) {

		$id = $this->getID();
                $query = "SELECT id FROM user WHERE id='".sqlite_escape_string($id)."'";
                $result = $db->query("$query");
                if (DB::isError($result)) {
                        print "Error: " . __FUNCTION__ . "() in " . __FILE__;
                        print_r($result);
                        return TRUE;
                }
		$query = "DELETE FROM user WHERE id='".sqlite_escape_string($id)."'";
                $result = $db->query("$query");
                if (DB::isError($result)) {
                        print "Error: " . __FUNCTION__ . "() in " . __FILE__;
                        print_r($result);
                        return TRUE;
                }
		return FALSE;
	}

	function insert($db) {   
		global $i18n;

		$query = "SELECT * FROM user WHERE login='".sqlite_escape_string($this->getLogin())."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getLogin() . " ". $i18n["already_exists"];

		$query = "
			INSERT INTO user (login, firstname, lastname, password, is_admin)
			VALUES ('".
				sqlite_escape_string($this->getLogin())."', '".
				sqlite_escape_string($this->getFirstName())."', '".
				sqlite_escape_string($this->getLastName())."', '".
				sqlite_escape_string($this->getPassword())."', '".
				sqlite_escape_string($this->getAdmin())."')
		";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}

}

?>
