<?

include_once "App.php";	
include_once "AbstractActionForm.php";
	
class addAppForm extends AbstractActionForm {
	
	function addAppForm() {
		parent::AbstractActionForm();
		$this->error = array();
		$this->submit = 0;
	}
	
	function setAppName($name) {
		global $i18n;
		global $proxy_address;
		if (!ereg('^[a-z0-9_\.-]+$', $name)) $this->addError('name', $i18n["internet"]." ".$i18n["invalid"]);
		if ($name == $proxy_address) $this->addError('name', $i18n["name_is_auth"]);
		$this->name = $name;
	}
	
	function getAppName() {
		return $this->name;
	}
	
	function setAppAlias($alias) {
		global $i18n;
		global $proxy_address;
		$alias = ereg_replace(" ","",$alias);
		foreach (explode(",",$alias) as $als) {
			if ($als=="")
				continue;
			if (!ereg('^[a-z0-9_\.\\\*-]+$', $als))
				$this->addError('als', $i18n["alias"]." ".$i18n["invalid"]);
			if ($als == $proxy_address)
				$this->addError('als', $i18n["alias"]." ".$i18n["invalid"]. " (" .$i18n["alias_is_auth"] .")" );
		}
		$this->alias = $alias;
	}
	
	function getAppAlias() {
		return $this->alias;
	}
	
	function setAppUrl($url) {
		global $i18n;
		$this->url = $url;
	}
	
	function getAppUrl() {
		return $this->url;
	}
	
	function setAppAuth($auth) {
		$this->auth = $auth;
	}
	
	function getAppAuth() {
		return $this->auth;
	}
	
	function setAppIface($iface) {
		global $i18n;
		if ($iface=="") $this->addError('if', $i18n["if"]." ".$i18n["invalid"]);
		$this->iface = $iface;
	}
	
	function getAppIface() {
		return $this->iface;
	}
	
	function setAppLog($log) {
		global $i18n;
		if (!ereg('^[[:digit:]]+$', $log)) $this->addError('log', $i18n["log"]." ".$i18n["invalid"]);
		$this->log = $log;
	}
	
	function getAppLog() {
		return $this->log;
	}
	
	function setAppFilter($filter) {
		$this->filter = $filter;
	}
	
	function getAppFilter() {
		return $this->filter;
	}

	function getAppHaveAccess() {
                return $this->have_access;
        }

        function setAppHaveAccess($flag) {
                $this->have_access = $flag;
        }

        function getAppAccessConfig() {
                return $this->access_config;
        }

        function setAppAccessConfig($access_config) {
                $this->access_config = $access_config;
        }
	
	function getAppID() {
		return $this->app_id;
	}
	
	function setAppID($id) {
		$this->app_id = $id;
	}
	
	function getSubmit() {
		return $this->submit;
	}
	
	function setSubmit($submit) {
		$this->submit = $submit;
	}
	
	function getAppHaveRewrite() {
		return $this->have_rewrite;
	}

	function setAppHaveRewrite($flag) {
		$this->have_rewrite = $flag;
	}
	
	function getAppHaveSecurity() {
		return $this->have_security;
	}

	function setAppHaveSecurity($flag) {
		$this->have_security = $flag;
	}
	
	function getAppRewrite() {
		return $this->rewrite;
	}

	function setAppRewrite($rewrite_rules) {
		$this->rewrite = $rewrite_rules;
	}
	
	function setAppHasHeaders($flag) {
		$this->has_headers = ($flag == "1");
	}
	
	function getAppHasHeaders() {
		return $this->has_headers;
	}

	function getAppHeaderID() {
		return $this->header_id;
	}

	function setAppHeaderID($header_id) {
		$this->header_id = $header_id;
	}

	function getAppHeaderVar() {
		return $this->header_var;
	}

	function setAppHeaderVar($header_var) {
		$this->header_var = $header_var;
	}

	function getAppHeaderValue() {
		return $this->header_value;
	}

	function setAppHeaderValue($header_value) {
		$this->header_value = $header_value;
	}


	function getAppFilterConfig() {
		return $this->filter_config;
	}

	function setAppFilterConfig($filter_config) {
		$this->filter_config = $filter_config;
	}

	function setAppIsPost($flag) {
		$this->app_is_post = $flag;
	}

	function getAppIsPost() {
		return $this->app_is_post;
	}

	function getPostUrl() {
		return $this->post_url;
	}

	function setPostUrl($url) {
		$this->post_url = $url;
	}
	
	function getFieldDesc() {
		return $this->field_desc;
	}

	function setFieldDesc($field_desc) {		
		$this->field_desc = sqlite_escape_string($field_desc);
	}

	function getFieldVar() {
		return $this->field_var;
	}
	
	function setFieldVar($field_var) {
		$this->field_var = $field_var;
	}

	function getFieldType() {
		return $this->field_type;
	}

	function setFieldType($field_type) {
		$this->field_type = $field_type;
	}

	function getFieldValue() {
		return $this->field_value;
	}

	function setFieldValue($field_value) {
		$this->field_value = sqlite_escape_string($field_value);
	}

	function getIsDelPost() {
		return $this->is_del_post;
	}

	function setIsDelPost($flag) {
		$this->is_del_post = $flag;
	}
	
	function setIsAddPost($flag) {
		$this->is_add_post = $flag;
	}

	function getIsAddPost() {
		return $this->is_add_post;
	}


	function getAppPostUrl() {
		return $this->post_url;
	}

	function setAppPostUrl($url) {
		global $i18n;
		if ($url == "") {
			$this->addError('post_url', $i18n["post_url"]." ".$i18n["invalid"]);
		}
		$this->post_url = $url;
	}

	function setAppSSOForwardType($type) {
		$this->sso_forward_type = $type;
	}
	
	function getAppSSOForwardType() {
		return $this->sso_forward_type;
	}
	
	function setAppAutoLogon($autologon) {
		if ($autologon=="on" || $autologon=="t") $autologon="t";
                else $autologon="f";
		$this->autologon = $autologon;
	}
	
	function getAppAutoLogon() {
		return $this->autologon;
	}

	function reset (&$request) {

		/* Build the authentication method list */
		$db     = $this->getDS('MyDS');
		$query = "SELECT id, type, id_auth FROM auth ORDER BY id";
		$result = $db->query("$query");
		$auth = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			if ($row['type'] == 1) {
				$query = "SELECT name FROM ldap WHERE id='".$row['id_auth']."'";
				$ldap_result = $db->query($query);
				$ldap_row = $ldap_result->fetchRow(DB_FETCHMODE_ASSOC);
				array_push($auth, array('id' => $row['id'], 'name' => $ldap_row['name']));
			}
			if ($row['type'] == 2) {
				$query = "SELECT name FROM ca WHERE id='".$row['id_auth']."'";
				$ca_result = $db->query($query);
				$ca_row = $ca_result->fetchRow(DB_FETCHMODE_ASSOC);
				array_push($auth, array('id' => $row['id'], 'name' => $ca_row['name']));
			}
	    		if ($row['type'] == 3) {
				$query = "SELECT name FROM sql WHERE id='".$row['id_auth']."'";
	      			$sql_result = $db->query($query);
	      			$sql_row = $sql_result->fetchRow(DB_FETCHMODE_ASSOC);
	      			array_push($auth, array('id' => $row['id'], 'name' => $sql_row['name']));
	    		}
		}

		/* Build the interface list */
		$query = "SELECT id, name FROM if ORDER BY name";
		$result = $db->query("$query");
		$iface=array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($iface, array('id' => $row['id'], 'name' => $row['name']));
		}
		
		/* Build the log format list */
		$query = "SELECT id, name FROM log ORDER BY name";
		$result = $db->query("$query");
		$log=array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($log, array('id' => $row['id'], 'name' => $row['name']));
		}


		/* Build the filter list */
		$query = "SELECT id, name FROM filter ORDER BY name";
		$result = $db->query("$query");
		$filter=array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($filter, array('id' => $row['id'], 'name' => $row['name']));
		}
		
		/* Build the POST variable list */
		$query = "SELECT p.id, p.field_desc, p.field_var, p.field_type, p.field_value FROM post p, app a WHERE a.id = p.id_app AND a.id='".$this->getAppID()."'";
		$result = $db->query($query);
		$post_vars = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($post_vars, array('id'		=> stripslashes($row['p.id']),
						     'field_desc'	=> stripslashes($row['p.field_desc']),
						     'field_var'	=> stripslashes($row['p.field_var']),
						     'field_type'	=> stripslashes($row['p.field_type']),
						     'field_value'	=> stripslashes($row['p.field_value']),
						     ));
		}

		$request->setAttribute('name',		stripslashes ($this->getAppName()));
		$request->setAttribute('alias',		stripslashes ($this->getAppAlias()));
		$request->setAttribute('url',		stripslashes ($this->getAppUrl()));
		$request->setAttribute('auth',		$auth);
		$request->setAttribute('iface',		$iface);
		$request->setAttribute('log',		$log);
		$request->setAttribute('filter',	$filter);
		$request->setAttribute('selected',	stripslashes ($this->getAppAuth()));
		$request->setAttribute('selected_iface',stripslashes ($this->getAppIface()));
		$request->setAttribute('selected_log',	stripslashes ($this->getAppLog()));
		$request->setAttribute('selected_filter',$this->getAppFilter());
		$request->setAttribute('have_rewrite',	stripslashes ($this->getAppHaveRewrite()));
		$request->setAttribute('has_headers', 	$this->getAppHasHeaders());
		$request->setAttribute('have_access',	stripslashes ($this->getAppHaveAccess()));
		$request->setAttribute('have_security',	stripslashes ($this->getAppHaveSecurity()));
		$request->setAttribute('id',		stripslashes ($this->getAppID()));
		$request->setAttribute('is_post',	stripslashes ($this->getAppIsPost()));
		$request->setAttribute('sso_forward_type',stripslashes ($this->getAppSSOForwardType()));
		$request->setAttribute('autologon',	stripslashes ($this->getAppAutoLogon()));
		$request->setAttribute('post_url',	stripslashes ($this->getAppPostUrl()));
		$request->setAttribute('rewrite_rules',	stripslashes ($this->getAppRewrite()));
		$request->setAttribute('filter_config',	stripslashes ($this->getAppFilterConfig()));
		$request->setAttribute('access_config',	stripslashes ($this->getAppAccessConfig()));		
	}

	function validate(&$mapping, &$request) {
		if ($request->getParameter('del_post') || $request->getParameter('add_post')) {
			$this->setIsDelPost($request->getParameter('del_post'));
			$this->setIsAddPost($request->getParameter('add_post'));
			$this->setAppIsPost(1);
			$this->setPostUrl	($request->getParameter('post_url'));
			$this->setFieldDesc	($request->getParameter('field_desc'));
			$this->setFieldVar	($request->getParameter('field_var'));
			$this->setFieldType	($request->getParameter('field_type'));
			$this->setFieldValue	($request->getParameter('field_value'));
		}

		$this->setAppHeaderID		($request->getParameter('header_id'));
		$this->setAppHeaderVar 		($request->getParameter('header_var'));
		$this->setAppHeaderValue 	($request->getParameter('header_value'));
		$this->setAppHasHeaders		($request->getParameter('has_headers'));
		
		if ($request->getParameter('submit') ||
		    $request->getParameter('add_post') ||
		    $request->getParameter('del_post')
		    ) {

			$this->setAppName	($request->getParameter('name'));
			$this->setAppAlias	($request->getParameter('alias'));
			$this->setAppUrl	($request->getParameter('url'));
			$this->setAppAuth	($request->getParameter('auth'));
			$this->setAppIface	($request->getParameter('iface'));
			$this->setAppLog	($request->getParameter('log'));
			$this->setAppAutoLogon	($request->getParameter('autologon'));

			
			if ($request->getParameter('rewrite')) {
				$this->setAppHaveRewrite(1);
				$this->setAppRewrite	($request->getParameter('rewrite_rules'));
			}
			if ($request->getParameter('access')) {
				$this->setAppHaveAccess(1);
				$this->setAppAccessConfig($request->getParameter('access_config'));
			}
			if ($request->getParameter('security')) {
				$this->setAppHaveSecurity(1);
				$this->setAppFilter	 ($request->getParameters('filter'));
				$this->setAppFilterConfig($request->getParameter('filter_config'));
			}
			if ($request->getParameter('post')) {
				$this->setAppSSOForwardType($request->getParameters('sso_forward_type'));
				$this->setAppIsPost(1);
				if ($request->getParameters('sso_forward_type') == "post") $this->setAppPostUrl($request->getParameters('post_url'));
			}
			else {
				$this->setAppSSOForwardType("");
				$this->setAppIsPost(0);
			}
		}
		if ($request->getParameter('id'))
			$this->setAppID($request->getParameter('id'));
		$request->setAttribute('ACTION_FORM', $this);
	}

}

?>
