<?php
	
include_once "AbstractAction.php";
include_once "Filter.php";
	
class addFilter extends AbstractAction {
	
	function addFilter() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');
	
		if ($form->getSubmit() && !$form->getErrors()) {
			$db 	= $this->getDS('MyDS');
			$filter = new Filter();

			$filter->setName	($form->getFilterName());
			$filter->setRules	($form->getFilterRules());

			if ($err = $filter->insert($db)) {
				$form->addError	('name', $err);
				$form->reset	($request);
			}
			else	$this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);

		$request->setAttribute ('name', 	stripslashes ($request->getParameter ('name')));
		$request->setAttribute ('rules',	stripslashes ($request->getParameter ('rules')));
		$request->setAttribute('errors', 	$form->getErrors());

		return $this->getForward($mapping);
	}

}

?>
