<?
	
include_once "SQL.php";
include_once "AbstractActionForm.php";
	
class addHtpasswdForm extends AbstractActionForm {
	
	function addHtpasswdForm() {
		parent::AbstractActionForm();
		$this->error = array();
		$this->submit = 0;
	}
	
	function setHtpasswdName($name) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $name)) $this->addError('name', $i18n["description"]." ".$i18n["invalid"]);
		$this->name = $name;
	}
	
	function getHtpasswdName() {
		return $this->name;
	}
	
	function setHtpasswdFile($file) {
		global $i18n;		
		if (!ereg('^[[:alnum:]]+$', $file)) $this->addError('name', $i18n["path"]." ".$i18n["invalid"]);
		$this->file = $file;
	}
	
	function getHtpasswdFile() {
		return $this->file;
	}
	
	function getHtpasswdID() {
		return $this->id;
	}
	
	function setHtpasswdID($id) {
		$this->id = $id;
	}
	
	function setHtpasswdOK($ok) {
		$this->ok = $ok;
	}

	function setHtpasswdKO($ko) {
		$this->ko = $ko;
	}

	function getHtpasswdOK() {
		return $this->ok;
	}

	function getHtpasswdKO() {
		return $this->ko;
	}

	function getIsACL() {
		return $this->is_acl;
	}

	function setIsACL($is_acl) {
		$this->is_acl = $is_acl;
	}

	function getIsACLSubmit() {
		return $this->is_acl_submit;
	}

	function setIsACLSubmit($is_acl_submit) {
		$this->is_acl_submit = $is_acl_submit;
	}

	function getSubmit() {
		return $this->submit;
	}
	
	function setSubmit($submit) {
		$this->submit = $submit;
	}
	
	function reset(&$request) {
		$request->setAttribute('name', 			$this->getHtpasswdName());
		$request->setAttribute('file', 			$this->getHtpasswdFile());
		$request->setAttribute('id',    		$this->getHtpasswdID());
		$request->setAttribute('acl',    		$this->getIsACL());
	}
	
	function validate(&$mapping, &$request) {
		if ($request->getParameter('acl')) {
			$this->setIsACL(1);
		}
		if ($request->getParameter('submit')) {
			if ($request->getParameter('add_htpasswd')) {
				$this->setHtpasswdOK($request->getParameters('avail_htpasswd'));
				$this->setIsACL(1);
				$this->setIsACLSubmit(1);
			}
			if ($request->getParameter('remove_htpasswd')) {
				$this->setHtpasswdKO($request->getParameters('in_htpasswd'));
				$this->setIsACLSubmit(1);
				$this->setIsACL(1);
			}
			$this->setHtpasswdName($request->getParameter('name'));
			$this->setHtpasswdFile($request->getParameter('file'));
		}
		if ($request->getParameter('id')) $this->setHtpasswdID($request->getParameter('id'));
		$request->setAttribute('ACTION_FORM', $this );
	}
}
	
?>
