<?php
	
include_once "AbstractAction.php";
include_once "If.php";
	
class addIfSSL extends AbstractAction {
	
	function addIfSSL() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');
		$db = $this->getDS('MyDS');
	
		if ($form->getSubmit() && !$form->getErrors()) {
			$if = new Intf();

			$if->setName		($form->getIfName());
			$if->setIP		($form->getIfIP());
			$if->setPort		($form->getIfPort());
			$if->setLog		($form->getIfLog());
			$if->setEngine		($form->getIfEngine());
			$if->setKey		($form->getIfKey());
			$if->setCrt		($form->getIfCrt());
			$if->setChainFile	($form->getIfChainFile());
	
			if ($err=$if->insert($db)) {
				$form->addError	('name', $err);
				$form->reset	($request);
			}
			else    $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);
		
		/* Build the log format list */
                $query = "SELECT id, name FROM log ORDER BY name";
                $result = $db->query("$query");
                $log = array();
                while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
                        array_push($log, array('id' => $row['id'], 'name' => $row['name']));
                }
	
		$request->setAttribute('ip', 		$form->getIfIP());
		$request->setAttribute('name', 		$form->getIfName());
		$request->setAttribute('port',		$form->getIfPort());
		$request->setAttribute('log',		$log);
		$request->setAttribute('key', 		$form->getIfKey());
		$request->setAttribute('crt', 		$form->getIfCrt());
		$request->setAttribute('chainfile', 	$form->getIfChainFile());
		$request->setAttribute('engine', 	$form->getIfEngine());
		$request->setAttribute('is_ssl', 	$form->getIfisSSL());
		$request->setAttribute('errors', 	$form->getErrors());

		return $this->getForward($mapping);

	}

}

?>
