<?php
	
include_once "AbstractAction.php";
include_once "Logs.php";
	
class addLog extends AbstractAction {
	
	function addLog() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');
	
		if ($form->getSubmit() && !$form->getErrors()) {
			$db 	= $this->getDS('MyDS');
			$log = new Logs();

			$log->setName	($form->getLogName());
			$log->setRules	($form->getLogRules());

			if ($err = $log->insert($db)) {
				$form->addError	('name', $err);
				$form->reset	($request);
			}
			else	$this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);

		$request->setAttribute ('name', 	stripslashes ($request->getParameter ('name')));
		$request->setAttribute ('rules',	stripslashes ($request->getParameter ('rules')));
		$request->setAttribute('errors', 	$form->getErrors());

		return $this->getForward($mapping);
	}

}

?>
