<?php
	
include_once "AbstractAction.php";
include_once "User.php";
	
class addUser extends AbstractAction {
	
	function addUser() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {

		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		if ($form->getSubmit() && !$form->getErrors()) {
			$db 	= $this->getDS('MyDS');
			$user	= new User();
			
			$user->setLogin		($form->getUserLogin());
			$user->setFirstname	($form->getUserFirstName());
			$user->setLastname	($form->getUserLastName());
			$user->setPassword	($form->getUserPassword());
			$user->setAdmin		($form->getUserAdmin());

			if ($err = $user->insert($db)) {
				$form->addError	('name', $err);
				$form->reset	($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);
		
		$request->setAttribute ('login', 	stripslashes ($request->getParameter ('login')));
		$request->setAttribute ('firstname',	stripslashes ($request->getParameter ('firstname')));
		$request->setAttribute ('lastname', 	stripslashes ($request->getParameter ('lastname')));
		$request->setAttribute ('password', 	stripslashes ($request->getParameter ('password')));
		$request->setAttribute ('is_admin', 	stripslashes ($request->getParameter ('is_admin')));
		$request->setAttribute('errors', 	$form->getErrors());
	
		return $this->getForward($mapping);
	}
	
}

?>
