<?

include_once "User.php";	
include_once "AbstractActionForm.php";
	
class addUserForm extends AbstractActionForm {
	
	function addUserForm() {
		parent::AbstractActionForm();
		$this->error = array();
		$this->submit = 0;
	}
	
	function setUserLogin($login) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $login)) $this->addError('login', $i18n["login"]." ".$i18n["invalid"]);
		$this->login = $login;
	}
	
	function getUserLogin() {
		return $this->login;
	}
	
	function setUserFirstName($firstname) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $firstname)) $this->addError('firstname', $i18n["firstname"]." ".$i18n["invalid"]);
		$this->firstname = $firstname;
	}
	
	function getUserFirstname() {
		return $this->firstname;
	}
	
	function setUserLastName($lastname) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $lastname)) $this->addError('lastname', $i18n["lastname"]." ".$i18n["invalid"]);
		$this->lastname = $lastname;
	}
	
	function getUserLastname() {
		return $this->lastname;
	}
	
	function setUserPassword($pass) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $pass)) $this->addError('password', $i18n["password"]." ".$i18n["invalid"]);
		$this->pass = $pass;
	}
	
	function getUserPassword() {
		return $this->pass;
	}
	
	function setUserAdmin($is_admin) {
		if ($is_admin=="on" || $is_admin=="t") $is_admin="t";
		else $is_admin="f";
		$this->is_admin = $is_admin;
	}
	
	function getUserAdmin() {
		return $this->is_admin;
	}
	
	function getUserID() {
		return $this->id;
	}
	
	function setUserID($id='') {
		$this->id = $id;
	}
	
	function getSubmit() {
		return $this->submit;
	}
	
	function setSubmit($submit) {
		$this->submit = $submit;
	}

	function reset(&$request) {
		$request->setAttribute('login',		stripslashes ($this->getUserLogin()));
		$request->setAttribute('firstname',	stripslashes ($this->getUserFirstname()));
		$request->setAttribute('lastname',	stripslashes ($this->getUserLastname()));
		$request->setAttribute('password',	stripslashes ($this->getUserPassword()));
		$request->setAttribute('is_admin',	stripslashes ($this->getUserAdmin()));
		$request->setAttribute('id',    	$this->getUserID());
	}
	
	function validate(&$mapping, &$request) {

		global $i18n;

		if ($request->getParameter('submit')) {
			$this->setUserLogin	($request->getParameter('login'));
			$this->setUserLastName	($request->getParameter('lastname'));
			$this->setUserFirstName	($request->getParameter('firstname'));
			$this->setUserPassword	($request->getParameter('password'));
			$this->setUserAdmin	($request->getParameter('is_admin'));
		}
		if ($request->getParameter('id')) $this->setUserID($request->getParameter('id'));
		$request->setAttribute('ACTION_FORM', $this );
	}
}

?>
