<?php
	
include_once "AbstractAction.php";
include_once "CA.php";
	
class editCA extends AbstractAction {
	
	function editCA() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		$ca = new CA();
		$db = $this->getDS('MyDS');
		$ca->select($db, $form->getCAID());

		if ($form->getSubmit() && !$form->getErrors()) {
			
			$ca->setName		($form->getCAName());
			$ca->setConstraint	($form->getCAConstraint());
			$ca->setCrt		($form->getCACrt());
			$ca->setRequire		($form->getCARequire());
		
			if ($err = $ca->update($db)) {
				$form->addError('name', $error);
				$form->reset($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);
		else {
			$request->setAttribute('name', 		$ca->getName());
			$request->setAttribute('ssl_constraint',$ca->getConstraint());
			$request->setAttribute('crt', 		$ca->getCrt());
			$request->setAttribute('ca_require', 	$ca->getRequire());
			$request->setAttribute('id', 		$ca->getID());
		}

		$request->setAttribute('errors', $form->getErrors());
		
		return $this->getForward($mapping);
	}

}
	
?>
