<?php
	
include_once "AbstractAction.php";
include_once "Filter.php";
	
class editFilter extends AbstractAction {
	
	function editFilter() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		$filter = new Filter();
		$db 	= $this->getDS('MyDS');
		$filter->select($db, $form->getFilterID());

		if ($form->getSubmit() && !$form->getErrors()) {

			$filter->setName	($form->getFilterName());
			$filter->setRules	($form->getFilterRules());

			if ($err = $filter->update($db)) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);
		else {
			$request->setAttribute('name', 	$filter->getName());
			$request->setAttribute('rules', $filter->getRules());
			$request->setAttribute('id', 	$filter->getID());
		}
		
		$request->setAttribute('errors', $form->getErrors());
	
		return $this->getForward($mapping);
	}

}

?>
