<?

include_once "AbstractAction.php";
include_once "Htpasswd.php";

class editHtpasswd extends AbstractAction {
	
	function execute($mapping, $form, &$request, &$response) {
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		$ht = new Htpasswd();
		$db = $this->getDS('MyDS');
		$ht->select($db, $form->getHtpasswdID());

		$acl = $ht->getACL($db);

		if ($form->getIsACL()) {
			$request->setAttribute('acl', $form->getIsACL());
		}
		else {
			$request->setAttribute('acl', $ht->getIsACL());
		}
		if ($form->getIsACLSubmit() && $form->getHtpasswdOK() || $form->getHtpasswdKO()) {
			$acl->setHtpasswdOK($form->getHtpasswdOK());
			$acl->setHtpasswdKO($form->getHtpasswdKO());
			$ht->setIsACL(1);
			$ht->update($db);
			$request->setAttribute('id', $ht->getID());
			$form->reset($request);
			$this->setForward('ko');
		}
		elseif ($form->getSubmit() && !$form->getErrors() && !$form->getIsACLSubmit()) {
			$ht->setName($form->getHtpasswdName());
			$ht->setFile($form->getHtpasswdFile());
			$ht->setIsACL($form->getIsACL());
			if (($err = $ht->update($db))) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors())
			$form->reset($request);
		else {
			$request->setAttribute('name', $ht->getName());
			$request->setAttribute('file', $ht->getFile());
			$request->setAttribute('id',   $ht->getID());
		}
		if ($form->getIsACL() || $ht->getIsACL()) {
			$request->setAttribute('acl_ok', $acl->getHtpasswdOK());
			$request->setAttribute('acl_ko', $acl->getHtpasswdKO());
		}
		$request->setAttribute('errors', $form->getErrors());
		return $this->getForward($mapping);
	}
}
	
?>
