<?

$default_language       = 'fr';

$proxy_address	= "NEED TO BE CHANGED"; //Example: www.VultureAuth.com or 194.6.241.233
$proxy_port	= "NEED TO BE CHANGED"; //Example: 8080

/* Apache 2 location path */
$httpd                  = 'sudo /usr/sbin/httpd';
$httpd_root		= '/etc/httpd';
$kill			= 'sudo kill';

$apache_modules = "
LoadModule perl_module          $httpd_root/extramodules/mod_perl.so
LoadModule security_module	$httpd_root/extramodules/mod_security.so
LoadModule access_module	$httpd_root/modules/mod_access.so
LoadModule proxy_module		$httpd_root/modules/mod_proxy.so
LoadModule proxy_http_module    $httpd_root/modules/mod_proxy_http.so
LoadModule ssl_module		$httpd_root/extramodules/mod_ssl.so
LoadModule log_config_module    $httpd_root/modules/mod_log_config.so

";

$dbi_uri = "dbi:SQLite2:dbname=/var/www/VultureNG/sql/db";

/* VultureNG Installation Path */
$base_dir		= '/var/www/VultureNG';

$moduleRootDir          = $base_dir.'/www';
$appServerRootDir       = $moduleRootDir . '/phpmvc';
$intf_dir               = $base_dir.'/conf';


/* YOU DO NOT NEED TO MODIFY WHAT IS FOLLOWING */

// Setup the application specific ActionDispatcher (RequestDispatcher)
$actionDispatcher	= 'TestActionDispatcher';

// Set the OS Type [Optional] [UNIX|WINDOWS|MAC] if we have
// trouble detecting the server OS type. Eg: path errors.
$osType = 'UNIX';

// Relative path to the phpmvc configuration files
$configPath = './WEB-INF'; // no trailing slash

// Setup application class paths first
include $appServerRootDir.'/WEB-INF/classes/phpmvc/utils/ClassPath.php';

// Setup the app server paths
include $appServerRootDir.'/WEB-INF/GlobalPaths.php';

$globalPaths = GlobalPaths::getGlobalPaths();
$gPath = ClassPath::getClassPath($appServerRootDir, $globalPaths, $osType);

// Setup the module paths
include $moduleRootDir.'/WEB-INF/ModulePaths.php';
$modulePaths = ModulePaths::getModulePaths();
$mPath = ClassPath::getClassPath($moduleRootDir, $modulePaths, $osType);
$cPath = ClassPath::concatPaths($gPath, $mPath, $osType);

// And set the 'include_path' variables, as used by the file functions
ini_set('include_path', $cPath);
define('CLASSPATH', True);

// Include application specific classes
$globalPrependFiles = $appServerRootDir.'/WEB-INF/globalPrepend.php';
include_once $globalPrependFiles;
include_once $actionDispatcher.'.php';

?>
