<?

/* IE Sucks */
session_cache_limiter('public');

header('Pragma: no-cache');
session_start();

/* Set some PHP variables */
ini_set ("display_errors","0");
ini_set ("error_log", "syslog");
ini_set ("warn_log", "syslog");
ini_set ("display_startup_errors","0");
ini_set ("max_execution_time","60");

if (is_file ("config.php")) include "config.php";
else {
	echo "<CENTER><B>Please Create the config.php file</B></CENTER>";
	exit;
}

/* Get SESSION variables */
if (isset ($_SESSION["language"])) 	$language = $_SESSION["language"];
else 					$language=$default_language;
include "locales/$language.inc.php";

/* Be sure that 'register_globals ' is set to 'Off' in php.ini */
if (ini_get('register_globals')!="") {
	echo "<CENTER>".$i18n['set_register_globals']."</CENTER>";
	session_destroy();
	exit;
}

$start = FileUtils::utime();

// Startup configuration information for an php.MVC Web app
$appServerContext	= new AppServerContext;
$appServerConfig	= new AppServerConfig;
$appServerContext->setInitParameter('ACTION_DISPATCHER', $actionDispatcher);
$appServerConfig->setInitParameter('mapping', 'ActionMappingXXX');
$appServerConfig->setAppServerContext($appServerContext);


// Setup the php.MVC Web application controller
$actionServer = new ActionServer;
// Load Application Configuration
$oApplicationConfig = '';
$bootUtils = new BootUtils;
$oApplicationConfig = $bootUtils->loadAppConfig($actionServer, $appServerConfig, $configPath);

if($oApplicationConfig == NULL) {
	exit;
}

// Setup HTTP Request and add request attributes
$request = new HttpRequestBase;
$request->setAttribute(Action::getKey('APPLICATION_KEY'), $oApplicationConfig);
$request->setRequestURI($_SERVER['PHP_SELF']);


// Note: $_REQUEST was introduced in 4.1.0. There is no
// equivalent array in earlier versions.
$actionID = 'do';
if($_REQUEST != '') {
	// Retrieve the 'action path'. Eg: index.php?do=[logonForm]
	$doPath = BOOTUtils::getActionPath($_REQUEST, $actionID);
	if ($doPath=="") {
			session_destroy();
			session_name('vultureng');
			session_start();
			$_SESSION["css"] = "css/open-source.fr.css";
			$doPath="logon";
	}
} else {
	//	kill !!!
}

$request->setAttribute('ACTION_DO_PATH', $doPath);
$response = new HttpResponseBase;

if( $_SERVER['REQUEST_METHOD'] == 'GET' ) 	$actionServer->doGet($request, $response, $_GET);
elseif( $_SERVER['REQUEST_METHOD'] == 'POST' ) 	$actionServer->doPost($request, $response,$_POST, $_FILES);

?>
