<?php
/*
* $Header: /projects/vultureng/www/phpmvc/WEB-INF/globalPrepend.php,v 1.1.1.1 2005/03/07 08:20:45 vultureng Exp $
* $Revision: 1.1.1.1 $
* $Date: 2005/03/07 08:20:45 $
*
* ====================================================================
*
* License:	GNU Lesser General Public License (LGPL)
*
* Copyright (c) 2003 John C.Wildenauer.  All rights reserved.
*
* This file is part of the php.MVC Web applications framework
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.

* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.

* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


include_once 'FileUtils.php';
include_once 'HttpAppServer.php';
include_once 'ActionServer.php';
include_once 'AppServerConfig.php';
include_once 'AppServerContext.php';
include_once 'RuleSet.php';
include_once 'RuleSetBase.php';
include_once 'ConfigRuleSet.php';
include_once 'Digester.php';
include_once 'PhpMVC_Log.php';	// Class Log is depreciated. Use class PhpMVC_Log instead.
include_once 'Log.php';				// Loading Log class only for legacy applications
include_once 'HashMap.php';
include_once 'RequestBase.php';
include_once 'HttpRequestBase.php';
include_once 'ResponseBase.php';
include_once 'HttpResponseBase.php';
include_once 'RequestProcessor.php';
include_once 'ActionError.php';
include_once 'ActionErrors.php';
include_once 'ActionConfig.php';
include_once 'ForwardConfig.php';
include_once 'FormBeanConfig.php';
include_once 'ActionDispatcher.php';// required base ActionDispatcher class
include_once 'BootUtils.php';

// PEAR
// Comment out the PEAR includes if you are using external PEAR libraries
include_once 'PEAR.php';
include_once 'PearMysqlDataSource.php';
include_once 'PearPgsqlDataSource.php';
include_once 'PearSqliteDataSource.php';
include_once 'WEB-INF/lib/pear/HTTP_Upload/Upload.php'; 

// PlugIns
include_once 'APlugIn.php';
include_once 'SmartyPlugInDriver.php';
include_once 'Smarty.class.php';

// File Uploading
include_once 'UploadedFile.php';
include_once 'MultiPartUploadFileHandler.php';


// We can check if ConfigRuleSet has been loaded in our ".../module/WEB-INF/prepend.php"
define('CONFIGRULESET', "1");

?>