<?php
	
include_once "AbstractAction.php";
include_once "Htpasswd.php";

class HtpasswdAction extends AbstractAction {

	function execute($mapping, $form, &$request, &$response) {
	
		parent::execute($mapping, $form, $request, $response);
	
		$this->setForward('ko');
		$db = $this->getDS('MyDS');
	
		if (($del = $request->getParameter('del'))) {
			$ht = new Htpasswd();
			$ht->select($db, $del);
			if ($err = $ht->delete($db, $del)) {
				$request->setAttribute('errors', $err);
			}
		}
		$query = "SELECT id FROM htpasswd ORDER BY id";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);
		}
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$ht = new Htpasswd();
			$ht->select($db, $row['id']);
			$hts[] = $ht;
		}

		$request->setAttribute('hts', $hts);
		$this->setForward('ok');
	
		return $this->getForward($mapping);
	}
}

?>
