<?php

include_once "AbstractAction.php";
include_once "LDAP.php";

class LDAPAction extends AbstractAction {

	function LDAPAction() {
	}

	function execute($mapping, $form, &$request, &$response) {

		parent::execute();

		$this->setForward('ko');

		$db = $this->getDS('MyDS');
		$db->setFetchMode(DB_FETCHMODE_ASSOC);

		if (($del = $request->getParameter('del'))) {
                        $ldap = new LDAP();
			$ldap->select($db, $del);
                        if ($err = $ldap->delete($db, $del)) {
                                $request->setAttribute('errors', $err);
                        }
                }

		$query = "SELECT id FROM ldap ORDER BY name";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);
		}
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$ldap = new LDAP();
			$ldap->select($db, $row['id']);
			$ldaps[] = $ldap;
		}
		$request->setAttribute('ldaps', $ldaps);
		$this->setForward('ok');
		
		return $this->getForward($mapping);
	}
}
?>
