<?php

include_once "AbstractAction.php";
include_once "Logs.php";

class LogAction extends AbstractAction {

	function LogAction() {
	}

	function execute($mapping, $form, &$request, &$response) {

		parent::execute();

		$this->setForward('ko');
		$db = $this->getDS('MyDS');

		if (($del = $request->getParameter('del'))) {
			$log = new Logs();
			$log->select($db, $del);
			if ($err = $log->delete($db)) {
				$request->setAttribute('errors', $err);
			}
		}

		$query = "SELECT id FROM log ORDER BY name";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);
		}
		$logs = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$log = new Logs();
			$log->select($db, $row['id']);
			$logs[] = $log;
		}

		$request->setAttribute('logs', $logs);
		$this->setForward('ok');

		return $this->getForward($mapping);
	}
}

?>
