<?php
	
include_once "AbstractAction.php";
include_once "CA.php";
	
class addCA extends AbstractAction {
	
	function addCA() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');
	
		if ($form->getSubmit() && !$form->getErrors()) {
			$db = $this->getDS('MyDS');
			$ca = new CA();
			
			$ca->setName		($form->getCAName());
			$ca->setConstraint	($form->getCAConstraint());
			$ca->setCrt		($form->getCACrt());
			$ca->setRequire		($form->getCARequire());
	
			if ($err = $ca->insert($db)) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);
	
		$request->setAttribute('name', 		stripslashes ($request->getParameter ('name')));
		$request->setAttribute('ssl_constraint',stripslashes ($request->getParameter ('ssl_constraint')));
		$request->setAttribute('crt', 		stripslashes ($request->getParameter ('crt')));
		$request->setAttribute('ca_require', 	stripslashes ($request->getParameter ('ca_require')));
		$request->setAttribute('errors', 	$form->getErrors());
		
		return $this->getForward($mapping);
	}

}

?>
