<?
	
include_once "Filter.php";
include_once "AbstractActionForm.php";
	
class addFilterForm extends AbstractActionForm {
	
	function addFilterForm() {
		parent::AbstractActionForm();
		$this->error = array();
		$this->submit = 0;
	}
	
	function setFilterName($name) {
		global $i18n;
		if (!ereg('^[[:alnum:][:space:]_\.]+$', $name)) $this->addError('name', $i18n["description"]." ".$i18n["invalid"]);		
		$this->name = $name;
	}
	
	function getFilterName() {
		return $this->name;
	}
	
	function setFilterRules($rules) {
		global $i18n;
		if ($rules=="") $this->addError('rules', $i18n["rules"]." ".$i18n["invalid"]);
		$this->rules = $rules;
	}
	
	function getFilterRules() {
		return $this->rules;
	}
	
	function getFilterID() {
		return $this->id;
	}
	
	function setFilterID($id='') {
		$this->id=$id;
	}
	
	function getSubmit() {
		return $this->submit;
	}
	
	function setSubmit($submit) {
		$this->submit = $submit;
	}
	
	function reset(&$request) {
		$request->setAttribute('name', 	stripslashes ($this->getFilterName()));
		$request->setAttribute('rules', stripslashes ($this->getFilterRules()));
		$request->setAttribute('id',    $this->getFilterID());
	}
	
	function validate(&$mapping, &$request) {
	
		if ($request->getParameter('submit')) {
			$this->setFilterName	($request->getParameter('name'));
			$this->setFilterRules	($request->getParameter('rules'));
		}

		if ($request->getParameter('id')) $this->setFilterID($request->getParameter('id'));
		$request->setAttribute('ACTION_FORM', $this);
	}

}

?>
