<?php
	
include_once "AbstractAction.php";
include_once "Htpasswd.php";
	
class addHtpasswd extends AbstractAction {
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');
		if ($form->getSubmit() && !$form->getErrors()) {
			$db		= $this->getDS('MyDS');
			$htpasswd	= new Htpasswd();

			$htpasswd->setName($form->getHtpasswdName());
			$htpasswd->setFile($form->getHtpasswdFile());

			if ($err = $htpasswd->insert($db)) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else {
				$this->setForward('ok');
			}
		}
		elseif ($form->getErrors()) $form->reset($request);

		$request->setAttribute('name', stripslashes ($request->getParameter('name')));
		$request->setAttribute('path', stripslashes ($request->getParameter('path')));

		$request->setAttribute('errors', $form->getErrors());
		
		return $this->getForward($mapping);
	}

}

?>
