<?
	
include_once "Logs.php";
include_once "AbstractActionForm.php";
	
class addLogForm extends AbstractActionForm {
	
	function addLogForm() {
		parent::AbstractActionForm();
		$this->error = array();
		$this->submit = 0;
	}
	
	function setLogName($name) {
		global $i18n;
		if (!ereg('^[[:alnum:][:space:]_\.]+$', $name)) $this->addError('name', $i18n["description"]." ".$i18n["invalid"]);		
		$this->name = $name;
	}
	
	function getLogName() {
		return $this->name;
	}
	
	function setLogRules($rules) {
		global $i18n;
		if ($rules=="") $this->addError('rules', $i18n["rules"]." ".$i18n["invalid"]);
		$this->rules = $rules;
	}
	
	function getLogRules() {
		return $this->rules;
	}
	
	function getLogID() {
		return $this->id;
	}
	
	function setLogID($id='') {
		$this->id=$id;
	}
	
	function getSubmit() {
		return $this->submit;
	}
	
	function setSubmit($submit) {
		$this->submit = $submit;
	}
	
	function reset(&$request) {
		$request->setAttribute('name', 	stripslashes ($this->getLogName()));
		$request->setAttribute('rules', stripslashes ($this->getLogRules()));
		$request->setAttribute('id',    $this->getLogID());
	}
	
	function validate(&$mapping, &$request) {
	
		if ($request->getParameter('submit')) {
			$this->setLogName	($request->getParameter('name'));
			$this->setLogRules	($request->getParameter('rules'));
		}

		if ($request->getParameter('id')) $this->setLogID($request->getParameter('id'));
		$request->setAttribute('ACTION_FORM', $this);
	}

}

?>
