<?php
	
include_once "AbstractAction.php";
include_once "SQL.php";
	
class addSQL extends AbstractAction {
	
	function addSQL() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');
		if ($form->getSubmit() && !$form->getErrors()) {
			$db	= $this->getDS('MyDS');
			$sql	= new SQL();

			$sql->setName		($form->getSQLName());

			# Order matter for setDbType, setDbName and setDbHost to build DBI uri
			$sql->setDbType		($form->getSQLDbType());
			$sql->setDbName		($form->getSQLDbName());
			if ($form->getSQLDbHost())
				$sql->setDbHost($form->getSQLDbHost());

			$sql->setDbUser		($form->getSQLDbUser());
			$sql->setDbPassword	($form->getSQLDbPassword());
			$sql->setLoginColumn	($form->getSQLLoginColumn());
			$sql->setPasswordColumn	($form->getSQLPasswordColumn());
			$sql->setTableName	($form->getSQLTableName());
			if ($err = $sql->insert($db)) {
				$form->addError ('name', $err);
				$form->reset    ($request);
			}
			else {
				$this->setForward('ok');
			}
		}
		elseif ($form->getErrors()) $form->reset($request);

		$request->setAttribute ('name',			stripslashes ($request->getParameter ('name')));
		$request->setAttribute ('db_type', 		stripslashes ($request->getParameter ('db_type')));
		$request->setAttribute ('db_host', 		stripslashes ($request->getParameter ('db_host')));
		$request->setAttribute ('db_name', 		stripslashes ($request->getParameter ('db_name')));
		$request->setAttribute ('db_user', 		stripslashes ($request->getParameter ('db_user')));
		$request->setAttribute ('db_pass', 		stripslashes ($request->getParameter ('db_pass')));
		$request->setAttribute ('login_column',		stripslashes ($request->getParameter ('login_column')));
		$request->setAttribute ('password_column',	stripslashes ($request->getParameter ('password_column')));
		$request->setAttribute ('table_name', 		stripslashes ($request->getParameter ('table_name')));

		$request->setAttribute('errors', $form->getErrors());
		
		return $this->getForward($mapping);
	}

}

?>
