<?
	
include_once "SQL.php";
include_once "AbstractActionForm.php";
	
class addSQLForm extends AbstractActionForm {
	
	function addSQLForm() {
		parent::AbstractActionForm();
		$this->error = array();
		$this->submit = 0;
	}
	
	function setSQLName($name) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $name)) $this->addError('name', $i18n["description"]." ".$i18n["invalid"]);
		$this->name = $name;
	}
	
	function getSQLName() {
		return $this->name;
	}
	
	function setSQLDbUser($db_user) {
		global $i18n;
		if (!ereg('^[[:alnum:]]*$', $db_user)) $this->addError('db_user', $i18n["bdd_user"]." ".$i18n["invalid"]);
		$this->db_user = $db_user;
	}
	
	function getSQLDbUser() {
		return $this->db_user;
	}
	
	function setSQLDbPassword($db_password) {
		global $i18n;
		if (!ereg('^[[:alnum:]]*$', $db_password)) $this->addError('db_password', $i18n["bdd_password"]." ".$i18n["invalid"]);
		$this->db_password = $db_password;
	}
	
	function getSQLDbPassword() {
		return $this->db_password;
	}
	
	function getSQLID() {
		return $this->id;
	}
	
	function setSQLID($id) {
		$this->id = $id;
	}
	
	function setSQLDbType($db_type) {
		$this->db_type = $db_type;
	}
	
	function getSQLDbType() {
		return $this->db_type;
	}

	function setSQLDbHost($db_host) {
		$this->db_host = $db_host;
	}
	
	function getSQLDbHost() {
		return $this->db_host;
	}
	
	function setSQLDbName($db_name) {
		global $i18n;
		if (!ereg('^[[:alnum:]/_]+$', $db_name)) $this->addError('db_name', $i18n["bdd"]." ".$i18n["invalid"]);
		$this->db_name = $db_name;
	}
	
	function getSQLDbName() {
		return $this->db_name;
	}
	
	function setSQLTableName($table_name) {
		global $i18n;
		if ($table_name=="") $this->addError('table_name', $i18n["bdd_table"]." ".$i18n["invalid"]);
		$this->table_name = $table_name;
	}
	
	function getSQLTableName() {
		return $this->table_name;
	}
	
	function setSQLLoginColumn($login_column) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $login_column)) $this->addError('login_column', $i18n["bdd_field_u"]." ".$i18n["invalid"]);
		$this->login_column = $login_column;
	}
	
	function getSQLLoginColumn() {
		return $this->login_column;
	}
	
	function setSQLPasswordColumn($password_column) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $password_column)) $this->addError('password_column', $i18n["bdd_field_p"]." ".$i18n["invalid"]);
		$this->password_column = $password_column;
	}
	
	function getSQLPasswordColumn() {
		return $this->password_column;
	}
	
	function setSQLOK($ok) {
		$this->ok = $ok;
	}

	function setSQLKO($ko) {
		$this->ko = $ko;
	}

	function getSQLOK() {
		return $this->ok;
	}

	function getSQLKO() {
		return $this->ko;
	}

	function getIsACL() {
		return $this->is_acl;
	}

	function setIsACL($is_acl) {
		$this->is_acl = $is_acl;
	}

	function getIsACLSubmit() {
		return $this->is_acl_submit;
	}

	function setIsACLSubmit($is_acl_submit) {
		$this->is_acl_submit = $is_acl_submit;
	}

	function getSubmit() {
		return $this->submit;
	}
	
	function setSubmit($submit) {
		$this->submit = $submit;
	}
	
	function reset(&$request) {
		$request->setAttribute('name', 			$this->getSQLName());
		$request->setAttribute('db_type', 		$this->getSQLDbType());
		$request->setAttribute('db_host', 		$this->getSQLDbHost());
		$request->setAttribute('db_name', 		$this->getSQLDbName());
		$request->setAttribute('db_user', 		$this->getSQLDbUser());
		$request->setAttribute('db_pass', 		$this->getSQLDbPassword());
		$request->setAttribute('login_column', 		$this->getSQLLoginColumn());
		$request->setAttribute('password_column', 	$this->getSQLPasswordColumn());
		$request->setAttribute('table_name', 		$this->getSQLTableName());
		$request->setAttribute('id',    		$this->getSQLID());
		$request->setAttribute('acl',    		$this->getIsACL());
	}
	
	function validate(&$mapping, &$request) {
		if ($request->getParameter('acl')) {
			$this->setIsACL(1);
		}
		if ($request->getParameter('submit')) {
			if ($request->getParameter('add_sql')) {
				$this->setSQLOK($request->getParameters('avail_sql'));
				$this->setIsACL(1);
				$this->setIsACLSubmit(1);
			}
			if ($request->getParameter('remove_sql')) {
				$this->setSQLKO($request->getParameters('in_sql'));
				$this->setIsACLSubmit(1);
				$this->setIsACL(1);
			}
			$this->setSQLName		($request->getParameter('name'));
			$this->setSQLDbHost		($request->getParameter('db_host'));
			$this->setSQLDbType		($request->getParameter('db_type'));
			$this->setSQLDbName		($request->getParameter('db_name'));
			$this->setSQLDbUser		($request->getParameter('db_user'));
			$this->setSQLDbPassword		($request->getParameter('db_pass'));
			$this->setSQLPasswordColumn	($request->getParameter('password_column'));
			$this->setSQLLoginColumn	($request->getParameter('login_column'));
			$this->setSQLTableName		($request->getParameter('table_name'));
		}
	
		if ($request->getParameter('id')) $this->setSQLID($request->getParameter('id'));
		$request->setAttribute('ACTION_FORM', $this );
	}
}
	
?>
