<?php
	
include_once "AbstractAction.php";
include_once "Logs.php";
	
class editLog extends AbstractAction {
	
	function editLog() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		$log = new Logs();
		$db 	= $this->getDS('MyDS');
		$log->select($db, $form->getLogID());

		if ($form->getSubmit() && !$form->getErrors()) {

			$log->setName	($form->getLogName());
			$log->setRules	($form->getLogRules());

			if ($err = $log->update($db)) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);
		else {
			$request->setAttribute('name', 	$log->getName());
			$request->setAttribute('rules', $log->getRules());
			$request->setAttribute('id', 	$log->getID());
		}
		
		$request->setAttribute('errors', $form->getErrors());
	
		return $this->getForward($mapping);
	}

}

?>
