<?

include_once "AbstractAction.php";
include_once "SQL.php";

class editSQL extends AbstractAction {
	
	function editSQL() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		$sql = new SQL();
		$db = $this->getDS('MyDS');
		$sql->select($db, $form->getSQLID());

		$acl = $sql->getACL($db);

		if ($form->getIsACL()) {
			$request->setAttribute('acl', $form->getIsACL());
		}
		else {
			$request->setAttribute('acl', $sql->getIsACL());
		}
		if ($form->getIsACLSubmit() && $form->getSQLOK() || $form->getSQLKO()) {
			$acl->setSQLOK($form->getSQLOK());
			$acl->setSQLKO($form->getSQLKO());
			$sql->setIsACL(1);
			$sql->update($db);
			$request->setAttribute('id', $sql->getID());
			$form->reset($request);
			$this->setForward('ko');
		}
		elseif ($form->getSubmit() && !$form->getErrors() && !$form->getIsACLSubmit()) {
			$sql->setName		($form->getSQLName());

			# Order matter for setDbType, setDbName and setDbHost to build DBI uri
			$sql->setDbType		($form->getSQLDbType());
			$sql->setDbName		($form->getSQLDbName());
			if ($form->getSQLDbHost())
				$sql->setDbHost($form->getSQLDbHost());

			$sql->setDbUser		($form->getSQLDbUser());
			$sql->setDbPassword	($form->getSQLDbPassword());
			$sql->setLoginColumn	($form->getSQLLoginColumn());
			$sql->setPasswordColumn	($form->getSQLPasswordColumn());
			$sql->setTableName	($form->getSQLTableName());
			$sql->setIsACL		($form->getIsACL());

			if (($err = $sql->update($db))) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors())
			$form->reset($request);
		else {
			$request->setAttribute('name', 			$sql->getName());
			$request->setAttribute('db_type', 		$sql->getDbType());
			
			if ($sql->getDbPort())
				$db_port = ":".$sql->getDbPort();

			$request->setAttribute('db_host', 		$sql->getDbHost().$db_port);
			$request->setAttribute('db_name', 		$sql->getDbName());
			$request->setAttribute('db_user', 		$sql->getDbUser());
			$request->setAttribute('db_pass', 		$sql->getDbPassword());
			$request->setAttribute('login_column', 		$sql->getLoginColumn());
			$request->setAttribute('password_column', 	$sql->getPasswordColumn());
			$request->setAttribute('table_name', 		$sql->getTableName());
			$request->setAttribute('id',    		$sql->getID());
		}
		if ($form->getIsACL() || $sql->getIsACL()) {
			$request->setAttribute('acl_ok', $acl->getSQLOK());
			$request->setAttribute('acl_ko', $acl->getSQLKO());
		}
		$request->setAttribute('errors', $form->getErrors());
		return $this->getForward($mapping);
	}
}
	
?>
