<?php
	
include_once "AbstractAction.php";
include_once "User.php";
	
class editUser extends AbstractAction {
	
	function editUser() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {

		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		$user	= new User();
		$db	= $this->getDS('MyDS');
		$user->select($db, $form->getUserID());
	
		if ($form->getSubmit() && !$form->getErrors()) {
	
			$user->setLogin         ($form->getUserLogin());
			$user->setLastName      ($form->getUserLastName());
			$user->setFirstname     ($form->getUserFirstName());
			$user->setPassword      ($form->getUserPassword());
			$user->setAdmin         ($form->getUserAdmin());
			
			if (($err = $user->update($db))) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);
		else {
			$request->setAttribute('login', 	$user->getLogin());
			$request->setAttribute('firstname',	$user->getFirstName());
			$request->setAttribute('lastname', 	$user->getLastName());
			$request->setAttribute('password', 	$user->getPassword());
			$request->setAttribute('is_admin', 	$user->getAdmin());
			$request->setAttribute('id', 		$user->getID());
		}
		
		$request->setAttribute('errors', $form->getErrors());
	
		return $this->getForward($mapping);
	}
}

?>
