<?php

	$i18n			= array();
	
	$i18n["set_register_globals"] = "Positionnez la variable register_globals  Off dans php.ini";

	/* Common Label */
	$i18n ["add"]		= "Add";
	$i18n ["attr"]		= "Attributes";
	$i18n ["path"]		= "File path";
	$i18n ["edit"]		= "Edit";
	$i18n ["delete"]	= "Delete";
	$i18n ["send"]		= "Send";
	$i18n ["action"]	= "Action";
	$i18n ["description"]	= "Description";
	$i18n ["confirm"]	= "Deletion : Are you sure?";
	$i18n ["type"]		= "Type";
	$i18n ["invalid"]	= "Invalid";
	$i18n ["already_exists"]= "Already exists.";
	$i18n ["invalid_cert"]	= "Invalide certificate";
	$i18n ["invalid_key"]	= "Invalide private key";
	$i18n ["breach"]	= "! Acces Denied !";

	/* Authentication */
	$i18n ["auth"]		= "Authentication";
	$i18n ["logon"]		= "Logon";
	$i18n ["logout"]	= "Logout";
	$i18n ["access_denied"]	= "Please authenticate";

	/* User */
	$i18n ["user"]		= "Users";
	$i18n ["login"]		= "Login";
	$i18n ["lastname"]	= "Last name";
	$i18n ["firstname"]	= "First name";
	$i18n ["password"]	= "Password";
	$i18n ["admin"]		= "Administrator";
	$i18n ["add_user"]	= "User add";
	$i18n ["edit_user"]	= "User edit";
	$i18n ["is_admin"]	= "User is a Vulture administrator";

	/* Applications */
	$i18n["app"]		= "Applications";
	$i18n["add_app"]	= "Application add";
	$i18n["edit_app"]	= "Application edit";
	$i18n["internet"]	= "Internet name";
	$i18n["alias"]		= "Alias";
	$i18n["private"]	= "Private URL";
	$i18n["auth_method"]	= "Authentication Methods";
	$i18n["rewrite"]	= "Rewriting rules";
	$i18n["access"]		= "Access Control";
	$i18n["iface"]		= "Network interface";
	$i18n["activate_rewrite"]	= "URL rewriting";
	$i18n["deactivate_rewrite"]	= "No URL rewriting";
	$i18n["activate_access"]        = "Access control";
        $i18n["deactivate_access"]      = "NO Access control";
	$i18n["activate_security"]	= "URL filtering";
	$i18n["deactivate_security"]	= "No URL filtering";
	$i18n["activate_post"]          = "SSO Forward &reg;";
        $i18n["deactivate_post"]        = "NO SSO Forward &reg;";
        $i18n["sso_forward"]           = "SSO Forward &reg; : Authentication propagation";
	$i18n["profiles"]	= "Profiles";
	$i18n["_profiles"]	= "profiles";
	
	$i18n["post"]           = "Form authentication";
        $i18n["post_url"]       = "Authentication Form URL";
        $i18n["add_field"]      = "Add a field";
        $i18n["field_list"]     = "Field list";
        $i18n["field_desc"]     = "Field description";
        $i18n["field_var"]      = "Variable name";
        $i18n["field_type"]     = "Field type";
        $i18n["field_value"]    = "Default Value";
        $i18n["basic"]          = "Basic authentication";
        $i18n["name_is_auth"]   = "Use of this Internet name is prohibited, because it is related to the authentication proxy";
        $i18n["alias_is_auth"]  = "Related to the authentication proxy";
        $i18n["autologon"]      = "Application's login/password and Vulture's login/password are identical";
	$i18n["autologon_missing"] = "Please define a 'autologon_user' field and a 'autologon_password' field";


	/* Interfaces */
	$i18n["interface"]	= "Interfaces";
	$i18n["ip_address"]	= "IP Address";
	$i18n["ip_port"]	= "Port";
	$i18n["status"]		= "Status";
	$i18n["add_if"]		= "Interface add";
	$i18n["edit_if"]	= "Interface edit";
	$i18n["activate_ssl"]	= "SSL activation";
	$i18n["deactivate_ssl"]	= "SSL canceling";
	$i18n["ca_crt"]		= "Certification authority certificate";
	$i18n["ca_chain"]	= "Certification authority chain";
	$i18n["server_crt"]	= "Interface related certificate";
	$i18n["server_key"]	= "Related private key";
	$i18n["ca_chain"]	= "Certification chain";
	$i18n["upload_msg"]	= "Key or certificatate upload";
	$i18n["pkcs12_msg"]	= "If the file is a PKCS#12 type";
	$i18n["status_ok"]	= "Interface up";
	$i18n["status_ko"]	= "Interface down";
	$i18n["status_stop"]	= "Putting down interface";
	$i18n["status_start"]	= "Interface activation";
	$i18n["if_used"]	= "This interface is used by some applications";
	$i18n["engine"]		= "Hardware SSL Accelerator";

	/* Authentication Method */
	$i18n["sql_auth"] 	= "SQL database authentication";
	$i18n["ca_auth"] 	= "Digital certificate authentication";
	$i18n["ldap_auth"] 	= "LDAP authentication";
	$i18n["htpasswd_auth"] 	= "Htpasswd file authentication";
	$i18n["sql"] 		= "SQL";
	$i18n["ldap"] 		= "LDAP";
	$i18n["ssl"] 		= "SSL";
	$i18n["htpasswd"]	= "Htpasswd";
	$i18n["auth_used"]	= "This authentication method is used by some applications";

	$i18n["bdd"] 		= "Database";
	$i18n["bdd_host"] 	= "Database address";
	$i18n["bdd_user"] 	= "SQL user name";
	$i18n["bdd_password"] 	= "Associated password";
	$i18n["bdd_table"] 	= "SQL table name";
	$i18n["bdd_field_u"] 	= "User field name";
	$i18n["bdd_field_p"] 	= "Password field name";
	$i18n["ldap_addr"]	= "LDAP server IP Address";
	$i18n["ldap_port"]	= "Port";
	$i18n["ldap_base_dn"]	= "Searching suffix in LDAP directory";
	$i18n["ldap_dn"]	= "Connection DN";
	$i18n["ldap_password"]	= "Connection DN associated password";
	$i18n["ldap_user_attr"]	= "User attributes";
	$i18n["ldap_group_attr"]= "Group attributes";
	$i18n["ldap_group_member"]= "Searching attribute in groups";
	$i18n["ldap_group_is_dn"]= "Searching attibute is a DN";

	$i18n["enable_acl"]	= "Access list administration";
	$i18n["acl_enabled"]	= "Adminitrate an access list";
	$i18n["disable_acl"]	= "Allow for all";
	$i18n["user_access"]	= "Access list by user";
	$i18n["group_access"]	= "Acess list by group";
	$i18n["avail_user"]	= "Available users list";
	$i18n["in_user"]	= "Authorized users list";
	$i18n["avail_group"]	= "Available groups list";
	$i18n["in_group"]	= "Authorized groups list";

	/* CA */
	$i18n["ca_require"]	= "Client Certificate Verification";
	$i18n["none"]		= "None";
	$i18n["optional"]	= "Optional";
	$i18n["require"]	= "Require";
	$i18n["ssl_constraint"]	= "SSL constraint (mod_ssl syntax)";

	/* Stats */
	$i18n["stat"] 		= "Statistics";

	/* Filtering */
	$i18n["filter"]		= "Applicatives filter";
	$i18n["filter_config"] 	= "Mod_security configuration";
	$i18n["rules"]		= "Rgles de filtrage";
	$i18n["add_filter"]	= "Add an applicative filter";
	$i18n["edit_filter"]	= "Edit an applicative filter";
	$i18n["filter_used"]	= "This filter is used by some applications";

	/* Log */
	$i18n["log"]		= "Log Formats";
	$i18n["log_title"]	= "Log Formats";
	$i18n["add_log"]	= "Add a log format";
	$i18n["edit_log"]	= "Edit a log format";
	$i18n["log_used"]	= "This log format is used";
	$i18n["log_rules"]	= "Apache Directives";
	
?>

