<?php
/*
* $Header: /projects/vultureng/www/phpmvc/WEB-INF/GlobalPaths.php,v 1.1.1.1 2005/03/07 08:20:45 vultureng Exp $
* $Revision: 1.1.1.1 $
* $Date: 2005/03/07 08:20:45 $
*
* ====================================================================
*
* License:	GNU Lesser General Public License (LGPL)
*
* Copyright (c) 2003 John C.Wildenauer.  All rights reserved.
*
* This file is part of the php.MVC Web applications framework
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.

* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.

* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
* The application-wide paths
*
* @author John C Wildenauer
* @version $Revision: 1.1.1.1 $
* @public
*/
class GlobalPaths {

	/**
	* Return an array of global paths
	* 
	* @public
	* @returns array	
	*/
	function getGlobalPaths() {

		// Setup the main phpmvc application include() directories here
		// Note: could be placed in a n xml config file later !!
		$appDirs = array();
		$appDirs[] = ''; // application root directory
		$appDirs[] = 'WEB-INF';
		$appDirs[] = 'WEB-INF/lib/collections';
		$appDirs[] = 'WEB-INF/lib/database';
		$appDirs[] = 'WEB-INF/lib/digester';
		$appDirs[] = 'WEB-INF/lib/logging';
		$appDirs[] = 'WEB-INF/lib/pear';
		$appDirs[] = 'WEB-INF/lib/pear/DB';
		$appDirs[] = 'WEB-INF/lib/phplib';
		$appDirs[] = 'WEB-INF/lib/smarty';
		$appDirs[] = 'WEB-INF/lib/utils';
		$appDirs[] = 'WEB-INF/lib/validator';
		$appDirs[] = 'WEB-INF/classes/phpmvc/action';
		$appDirs[] = 'WEB-INF/classes/phpmvc/actions';
		$appDirs[] = 'WEB-INF/classes/phpmvc/appserver';
		$appDirs[] = 'WEB-INF/classes/phpmvc/config';
		$appDirs[] = 'WEB-INF/classes/phpmvc/connector';
		$appDirs[] = 'WEB-INF/classes/phpmvc/dbcp';
		$appDirs[] = 'WEB-INF/classes/phpmvc/plugins';
		$appDirs[] = 'WEB-INF/classes/phpmvc/upload';
		$appDirs[] = 'WEB-INF/classes/phpmvc/utils';

		return $appDirs;

	}

}
?>