<?php
/*
* $Header: /projects/vultureng/www/phpmvc/WEB-INF/classes/phpmvc/test/@PhpMVCTestSuite.php,v 1.1.1.1 2005/03/07 08:20:45 vultureng Exp $
* $Revision: 1.1.1.1 $
* $Date: 2005/03/07 08:20:45 $
*
* ====================================================================
*
* License:	GNU Lesser General Public License (LGPL)
*
* Copyright (c) 2002, 2003 John C.Wildenauer.  All rights reserved.
*
* This file is part of the php.MVC Web applications framework
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.

* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.

* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
* Main test suite for the php.MVC framework
*/

include_once 'phpunit.php';
include_once './ActionsTestCase.php';
include_once './MessageFormatTestCase.php';
include_once './PropertyMessageResourcesTestCase.php';
include_once './ActionChainsTestCase.php';

include_once './ClassPathTestCase.php';


$suite1 = new TestSuite( 'ActionsTestCase' );
$suite2 = new TestSuite( 'MessageFormatTestCase' );
$suite3 = new TestSuite( 'PropertyMessageResourcesTestCase' );
$suite4 = new TestSuite( 'ActionChainsTestCase' ); 

// Run ClassPathTestCase last as it alters the environment paths !
$suite100 = new TestSuite( 'ClassPathTestCase' );	


$suite = new TestSuite();
$suite->addTest( $suite1 );
$suite->addTest( $suite2 );
$suite->addTest( $suite3 );
$suite->addTest( $suite4 );

$suite->addTest( $suite100 );


echo '<STYLE TYPE="text/css">';
include ("stylesheet.css");
echo ' </STYLE>';

$result = new PrettyTestResult;
$suite->run($result);
$result->report();	// Dump the array


?>